//region
//could split this into types: region defined by edges, region defined by corners, sum of regions, regionset, other...

package jcm.mod;
import jcm.*;
import java.util.*;
import java.awt.*;

public class region extends iob {
	
	public String code; 
	public 	Color col; 
	public boolean dud=false, wrapping=false, included=false, fixedpoly=false, land=true; 
	public region superset=regionset.allreg; 
	
	
	//***************************************************
	//constructors
	public region (String s) {	code=s; }
	public region() {	code="unnamed region"; }
	
	
	//***************************************************
	//name and colors
	
	public void setcolor(Color c) {	col=c; }
	public Color getcolor() {	if (col==null) col=rcol(); return col; }
	public static Color rcol() {	return new Color((int)(255*Math.random()),(int)(255*Math.random()),(int)(255*Math.random())); }
	public void setcols(Color[] cols)  {	for (start(); more(); ) c.setcolor(cols[i]); }
	public Color[] getcols() {	Color[] cols=new Color[reg.size()]; for (start(); more(); ) cols[i]=c.getcolor(); return cols; }
	
	public String getname() {	return code; }
	public String[] getnames() {	String[] names=new String[reg.size()]; for (start(); more(); ) names[i]=c.code; return names; }
	
	//***************************************************
	//comparing order
	boolean lt(region r) {	return code.compareTo(r.code)<0; }
	boolean gt(region r) {	return code.compareTo(r.code)>0; }
	
	
	//***************************************************
	//vector of subregions
	public Vector reg=new Vector(); 
	Enumeration e; 
	public int i; public region c; //current
	
	public void start() {	e=reg.elements(); i=-1; }
	public boolean more() {	if (e.hasMoreElements()) {	i++; c= (region) e.nextElement(); return true; } return false; }
	
	public region find(String s) {
		for (int i=0; i<reg.size(); i++) {	region r=(region)reg.elementAt(i); if (r.code.equals(s)) return r; }
		region r=new region(s); 
		reg.addElement(r); 
		return r; 
	}
	
	public void put(region r) {	reg.addElement(r); }
	public void remove(region r) {	reg.removeElement(r.code); }
	public void put(region[] r) {	for (int i=0; i<r.length; i++) put(r[i]); }
	
	public boolean contains(region r) {	//recursive
		if (r==this) return true; 
		if (isset()) 	for (start(); more(); ) if (c.contains(r)) return true; 
		return false; 
	}
	
	public boolean isset() {	return reg.size()>0; }
	
	
	//***************************************************
	//set of polygons
	public Vector polyset=new Vector(); 
	Enumeration pe; 
	
	public void startpoly() {	polyset.removeAllElements(); pe=polyset.elements(); }
	public regpoly nextpoly() {	if (!pe.hasMoreElements()) polyset.addElement(new regpoly()); return (regpoly) pe.nextElement(); }
	public regpoly poly(int i) {	return (regpoly) polyset.elementAt(i); }
	
	public boolean contains(Point p) {	for (int j=0; j<polyset.size(); j++) if (poly(j).contains(p.x,p.y)) return true; return false; }
	
	
	//***************************************************
	//make polygon corresponding to a particular region
	public void makepolys() {	if (!fixedpoly) {	startpoly(); addpoly(this); }}
	
	//semi- recursive : poly and contains info always belongs to initial region
	public void addpoly(region ir) {
		String debug=" region "+ir.code; 
		try {
			if (ir.isset()) {
				for (ir.start(); ir.more(); )  ir.c.included=false; 
				//below doesn't work with start(), more() due to recursion!
				for (Enumeration e=ir.reg.elements(); e.hasMoreElements(); )  {	region r= (region) e.nextElement(); debug+=" "+r.code; if (!r.included) {	addpoly(r); debug+=":start "; } else  debug+=":inc "; }
				//				iob.debug(debug);
			}
			else {
				if (ir.fixedpoly) {
					regpoly p=nextpoly(); 
					p=(regpoly) ir.polyset.firstElement(); 
					ir.included=true; 
				}
				if (ir.startedge!=null) {
					//(follow around the edges anticlockwise)
					edge e=ir.startedge, eo=e; 
					region et, er, el; regpoly p; 
					boolean startok=false; 
					p=nextpoly(); p.wrapping=false; ir.included=true; 
					do {
						debug +=" edge "+(e!=null ? e.info() : " null"); 
						//if not internal edge, add edge
						if (!(contains(e.left) && contains(e.right)))  {
							if (!startok) {	eo=e; startok=true; }
							p.addedge(e, e.left==ir); 
						}
						//move on to next edge (/region)
						if (e.left==ir) {	et= e.to; er=e.right; el=e.left; } else {	et= e.from; er= e.left; el=e.right ; }
						if (contains(et)) {	ir=et; ir.included=true; e=ir.lt(er) ? ir.fef(er, el) : er.fet(ir, el) ; }
						else {	e=  ir.lt(et) ? ir.fef(et, er) : et.fet(ir, er) ; }
					} while (e!=eo && !p.wrapping); 
					//if (!mapproj.notwrap(fp.x,op.x)) {	p.wrapping=true; wrapping=true; }
				}
			}
		} catch (RuntimeException ex) {	iob.debug(ex+debug); }
	}
	
	
	//***************************************************
	//interpolate average for each polygon, from an instance of mapdata (GCM data, baseline climatology etc)
	/*	may need to put back regionset.resetdud(); which was called by regcli.precalc(iob) when new dataset
	public static void resetdud () {	for (Enumeration e = reg.elements() ; e.hasMoreElements() ; ((region) e.nextElement()).dud=false ); }
	*/
	
	/*
	Note Polygon.contains(x,y) is very inefficient for large polygons - it traces every edge segment
	So when bounding box is large, it's checking edges a long way away
	Hence map draws more efficiently with many small polygons despite increased total number of edges
	Could split into subboxes and use contains(x1,y1,x2,y2) method? but that doesn't work in MS-JVM
	Code below works with both, but slow in MSJVM
	*/
	
	
	public float avg(mapdata d) {
		if ( (code.startsWith("PAC_") &&code.length()==6)) dud=true; else dud=false; 
		if (dud || wrapping) return -999; 
		
		regpoly p; Enumeration pe; 
		int xo,yo, xi, yi, xd, yd, cell; 
		double area=0, sum=0, sumarea=0, dudarea=0; 
		boolean inbox; 
		//		makepolys(); // -only when changed - which mapplot should ensure!
		for (pe=polyset.elements(); pe.hasMoreElements(); ) {
			p= (regpoly) pe.nextElement(); 
			Rectangle box=p.getBoundingBox(); 
			
			int step=5; // degree steps
			for (xo=box.x; xo<(box.x+box.width); xo+=step)	{
				xd=Math.min((box.x+box.width)-xo, step); 
				for (yo=box.y; yo<(box.y+box.height); yo+=step) {
					yd=Math.min((box.y+box.height)-yo, step); 
					if (p.intersects(xo,yo,xd,yd)) {
						inbox=p.contains(xo,yo,xd,yd); 
						for (yi=yo; yi<(yo+yd); yi++) {
							area=Math.cos((Math.PI*yi)/180.0); 
							for (xi=xo; xi<(xo+xd); xi++)	{
								if (inbox || p.contains(xi,yi)) {
									cell=findcell(xi,yi,d); 
									if (d.r[cell]!=-999) {	sum+=d.r[cell]*area; sumarea+=area; } else dudarea+=area; 
								}
							}
						}
					}
				}
			}
		} //polys
		if (sumarea>dudarea) {	dud=false; return (float)(sum/sumarea); } else {	dud=true; return -999; }
	} //regav
	
	int findcell(int x, int y, mapdata d) {
		int xx=(int)(0.5+d.nlon*((x+360)%360)/360.0); 
		int yy=(int)(0.5+d.nlat*(90-y)/180.0); 
		return yy*d.nlon+xx; 
	}
	
	//***************************************************
	//edges of each region
	edge[] ed=new edge[100]; int ne=0; 
	edge startedge; 
	
	edge fef(region r, region f) {	for (int n=0; n<ne; n++) if (r==ed[n].right && f==ed[n].from) return ed[n]; return null; }
	edge fet(region r, region t) {	for (int n=0; n<ne; n++) if (r==ed[n].right && t==ed[n].to) return ed[n]; return null; }
	
	edge addedge(String r, String f, String t)	{
		ed[ne]= new edge(this, superset.find(r), superset.find(f), superset.find(t)); 
		startedge=ed[ne]; 
		superset.find(r).startedge=ed[ne]; 
		ne++; return ed[ne-1]; 
	}
	
	//*****************************************************
	//methods called by loaddata
	public void addedge(String[] item) {
		edge e= addedge(item[1], item[2], item[3]); 
		e.p=new Point[item.length-4]; 
		for (int j=4; j<item.length; j++) e.p[j-4]=parsepoint(item[j]); 
	}
	
	//E, W, N, S edges, format of TGCIA regions - note this will trim the half degrees because Polygon only accepts ints
	public void defbox(String[] s) {
		regpoly p=new regpoly(); 
		p.addPoint(pi(s[5]), pi(s[2])); 
		p.addPoint(pi(s[5]), pi(s[3])); 
		p.addPoint(pi(s[4]), pi(s[3])); 
		p.addPoint(pi(s[4]), pi(s[2])); 
		polyset.addElement(p); fixedpoly=true; 
		superset.find("TGCIA").put(this); 
	}
	
	public void addsub(String[] item) {	for (int j=2; j<item.length; j++) 	put(superset.find(item[j])); }
	public void subtract(String[] item) {	for (int j=2; j<item.length; j++) 	remove(superset.find(item[j])); }
	public void addset(String[] item) {	for (int j=2; j<item.length; j++) {	region rr= superset.find(item[j]); for (rr.start(); rr.more(); ) put(rr.c); }	}
	
	public static int pi(String s) {	return Integer.parseInt(s.substring(0, s.length()-2)); }
	public static Point parsepoint(String item) {
		int k=nsew(item.substring(0,1)); 
		return new Point(xs*Integer.parseInt(item.substring(k+2,item.length())), ys*Integer.parseInt(item.substring(k,k+2)) ); 
	}
	
	//interpret NSEW info in datafile
	static int xs=1, ys=1; //assume start N, E
	static int nsew(String c) {
		int k=1; 
		if (c.equals("N"))  ys=1; 
		else if (c.equals("S")) ys=-1; 
		else if (c.equals("E")) xs=1; 
		else if (c.equals("W")) xs=-1; 
		else if (c.equals("!")); //to skip comments
		else k=0; 
		return k; 
	}
	//*****************************************************
	
	
	
	
} //end class
	
	//***************************************************
	
class regpoly extends Polygon {
	boolean wrapping=false; 
	
	public void addpoint(Point p) {	addPoint(p.x, p.y); }
	
	public void addedge(edge e, boolean forwards) {
		if (forwards) {
			if (e.left.gt(e.from)) addpoint(e.from.fef(e.left, e.right).p[0]); 
			for (int i=0; i<e.p.length; i++) addpoint(e.p[i]); 
		}
		else {	//reverse
			if (e.to.gt(e.left)) addpoint(e.left.fef(e.to, e.right).p[0]); 
			for (int i=e.p.length-1; i>=0; i--) addpoint(e.p[i]); 
		}
	}
	
	//two methods below don't work in MS JVM
	public boolean intersects(int x, int y, int w, int h) {	try {	return super.intersects(x,y,w,h); } catch (Error e) {	return true; } }
	public boolean contains(int x, int y, int w, int h) {	try {	return super.contains(x,y,w,h); } catch (Error e) {	return false; }	}
	
	/*
	public regpoly intersect (regpoly b) {
	Point p; Polygon c;
	for (int i=0; i<b.npoints-1; i++) p=intersect(xpoint[i], ypoint[i], xpoint[i+1], ypoint[i+1], b.xpoint[j], b.ypoint[j], b.xpoint[j+1], b.ypoint[j+1]);
	}
	
	public static Point intersect(int x1s, int y1s, int x1e, int y1e, int x2s, int y2s, int x2e, int y2e) {
	m1=(y1e-y1s)/(x1e-x1s), c1=y1-m1*x1;
	m2=(y2e-y2s)/(x2e-x2s), c2=y2-m2*x2;
	xi=(c2-c1)/(m1-m2), yi=m1*xi+c1;
	if (xi>x1s) && (xi<x2s) return new Point(xi,yi) else return null;
	}
	*/
}
	
	
class edge {
	region left, right, from, to; 
	Point[] p=new Point[0]; 
	edge(region l, region r, region f, region t) {	left=l; right=r; from=f; to=t; }
	edge() {	}
	boolean internal() {	return left.code.substring(0,3).equals(right.code.substring(0,3)); }
	
	String info() {	try {	return " l="+left.code + " r="+right.code + " f=" + from.code + " t="+to.code; } catch (RuntimeException e) {	return " noinfo "; }}
}
	
	
	/*
	//region 13 used to be for Denmark, could be used for any specific country
	//note region 13 data is *100, in order to preserve accuracy!
	//denmark data is Jesper's corrected kyoto data -kef would be 0.304 from cdiac & EUBSA -21%
	//currently denmark not shown and region 13 used for bunker fuels
	//note emissions data in MtC and population in millions
	//ef = shares of total emissions in 2000
	//double[] ef={	0.2363,0.0351,0.0489,0.1342,0.0368,0.0680,0.0575,0.1530,0.0578,0.0906,0.0317,0.0501,1,0.245};
	*/
	
	
	/*
	public region(String s, String[] sr) {	code=s; subreg=sr; }
	public region(String s, Color c, String[] sr) {	code=s; col=c; subreg=sr; }
	
	String[] subreg; //do i still use this?
	public region subreg(int i) {	return superset.find(subreg[i]); }
	//old contains	if (subreg==null) return r==this; for (int i=0; i<subreg.length; i++) if (subreg(i)==r) return true; return false; }
	*/
	
